#include <complex>
#include <cstdlib>

#ifndef INCLUDE_LAPACK_CALLS_H_
#include "lapacke.h"
#include "../include/lapack_calls.h"
#endif

using namespace std;

void zinvert(std::complex<double> **mat, lapack_int n, int &jer) {
  jer = 0;
  __complex__ double *arr = new __complex__ double[n * n];
  const __complex__ double uim = 1.0di;
  for (lapack_int i = 0; i < n; i++) {
    for (lapack_int j = 0; j < n; j++) {
      lapack_int idx = i + n * j;
      arr[idx] = mat[j][i].real() + uim * mat[j][i].imag();
    }
  }
  
  int* IPIV = new int[n]();
  
  LAPACKE_zgetrf(LAPACK_ROW_MAJOR, n, n, arr, n, IPIV);
  LAPACKE_zgetri(LAPACK_ROW_MAJOR, n, arr, n, IPIV);
  for (lapack_int i = 0; i < n; i++) {
    for (lapack_int j = 0; j < n; j++) {
      lapack_int idx = i + n * j;
      mat[j][i] = complex<double>(__real__ arr[idx], __imag__ arr[idx]);
    }
  }
  delete [] IPIV;
  delete [] arr;
}
